/* TODO: copyright
 */

#include "pgeng.h"

static int always_accept (unsigned int *g, int n, int maxn) {
    return 0;
}

// for testing
static int never_accept (unsigned int *g, int n, int maxn) {
    return 1;
}

static PRUNE_PLUGIN pgeng_prune_plugin = &always_accept;

static PRUNE_PLUGIN pgeng_preprune_plugin = &always_accept;

int pgeng_prune (unsigned int *g, int n, int maxn) {
    return (*pgeng_prune_plugin)(g, n, maxn);
}

int pgeng_preprune (unsigned int *g, int n, int maxn) {
    return (*pgeng_preprune_plugin)(g, n, maxn);
}

int geng_main_for_pgeng (int argc, char * argv[]); // defined in geng.c

int pgeng (int argc, char *argv[], PRUNE_PLUGIN prune, PRUNE_PLUGIN preprune) {
    pgeng_prune_plugin = prune ? prune : &always_accept;
    pgeng_preprune_plugin = preprune ? preprune : &always_accept;

    return geng_main_for_pgeng (argc, argv);
}
